% Stimulator GUI

%clean up any leftover serial connections
clear all

presets = ...
    [60,62,64,65,67,69,71,72;...%C major
    60,63,64,65,68,70,71,72;...%C minor
    49,38,47,35,36,46,44,57]; %drum kit

%open a window
figure('position',[200 200 280 600],...
    'name','MIDI Glove Control',...
    'numbertitle','off')
clf

% %open a serial connection
 %s = serial('COM5',...
 %    'baudrate',9600);
 %fopen(s)

%define note selection popups
x=20; y=560; w=100; h=20;
f1text = uicontrol('Style', 'text',...
       'String', 'Left Ring',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=560; w=100; h=20;
f1pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=520; w=100; h=20;
f2text = uicontrol('Style', 'text',...
       'String', 'Left Middle',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=520; w=100; h=20;
f2pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=480; w=100; h=20;
f3text = uicontrol('Style', 'text',...
       'String', 'Left Index',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=480; w=100; h=20;
f3pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=440; w=100; h=20;
f4text = uicontrol('Style', 'text',...
       'String', 'Left Thumb',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=440; w=100; h=20;
f4pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=400; w=100; h=20;
f5text = uicontrol('Style', 'text',...
       'String', 'Right Thumb',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=400; w=100; h=20;
f5pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=360; w=100; h=20;
f6text = uicontrol('Style', 'text',...
       'String', 'Right Index',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=360; w=100; h=20;
f6pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=320; w=100; h=20;
f7text = uicontrol('Style', 'text',...
       'String', 'Right Middle',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=320; w=100; h=20;
f7pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);
x=20; y=280; w=100; h=20;
f8text = uicontrol('Style', 'text',...
       'String', 'Right Ring',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=280; w=100; h=20;
f8pop = uicontrol('Style', 'popup',...
       'String', 'C1|C1#|D1|D1#|E1|F1|F1#|G1|G1#|A2|A2#|B2|C2|C2#|D2|D2#|E2|F2|F2#|G2|G2#|A3|A3#|B3|C3|C3#|D3|D3#|E3|F3|F3#|G3|G3#|A4|A4#|B4|C4|C4#|D4|D4#|E4|F4|F4#|G4|G4#|A5|A5#|B5|C5|C5#|D5|D5#|E5|F5|F5#|G5|G5#|A6|A6#|B6|C6|C6#|D6|D6#|E6|F6|F6#|G6|G6#|A7|A7#|B7|C7',...
       'fontsize',12,...
       'Position', [x y w h]);

%define presets
x=20; y=200; w=100; h=20;
presettext = uicontrol('Style', 'text',...
       'String', 'Preset',...
       'fontsize',12,...
       'Position', [x y w h]);
x=140; y=200; w=100; h=20;
presetpop = uicontrol('Style', 'popup',...
       'String', 'C Major|C Minor|Drum Kit',...
       'fontsize',12,...
       'Position', [x y w h]);

%define the synth checkbox   
x=20; y=160; w=100; h=20;
synthtext = uicontrol('style','text',...
    'string','Sustain',...
    'fontsize',12,...
    'position',[x y w h]);
x=140; y=160; w=100; h=20;
synthcb = uicontrol('style','checkbox',...
    'position',[x y w h]);

%define the quit button
x=20; y=120; w=50; h=20;
exit=0;
quitbutton=uicontrol('style','pushbutton',...
   'string','Quit', ...
   'fontsize',12, ...
   'position',[x,y,w,h], ...
   'tag','stimcntl',...
   'callback','exit=1;close;');

%define the note map button
x=20; y=80; w=70; h=20;
setmap=0;
quitbutton=uicontrol('style','pushbutton',...
   'string','Manual', ...
   'fontsize',12, ...
   'position',[x,y,w,h], ...
   'tag','stimcntl',...
   'callback','setmap=1;');

%define the note map button
x=20; y=40; w=70; h=20;
preset=0;
quitbutton=uicontrol('style','pushbutton',...
   'string','Preset', ...
   'fontsize',12, ...
   'position',[x,y,w,h], ...
   'tag','stimcntl',...
   'callback','preset=1;');
   
while (exit==0)
    
    if(setmap)
        str = sprintf('%d %d %d %d %d %d %d %d %d',23+get(f1pop,'Value'),...
            23+get(f2pop,'Value'),23+get(f3pop,'Value'),23+get(f4pop,'Value'),...
            23+get(f5pop,'Value'),23+get(f6pop,'Value'),23+get(f7pop,'Value'),...
            23+get(f8pop,'Value'),get(synthcb,'Value'));
        fprintf(s,str);
        %fprintf(str);
        setmap = 0;
    end
    
    if(preset)
        presetNo = get(presetpop,'Value');
        str = sprintf('%d %d %d %d %d %d %d %d %d',presets(presetNo,1),...
            presets(presetNo,2),presets(presetNo,3),presets(presetNo,4),...
            presets(presetNo,5),presets(presetNo,6),presets(presetNo,7),...
            presets(presetNo,8),get(synthcb,'Value'));
        fprintf(s,str);
        %fprintf(str);
        preset = 0;
    end
    drawnow %force a window redraw   
end

%close the serial port
 %fclose(s)